import 'dart:convert';
import 'dart:developer';
import 'package:http/http.dart' as http;
import 'package:crypto/crypto.dart';
import 'package:flutter/material.dart';


class transactionStatusURL extends StatefulWidget {
  const transactionStatusURL({Key? key, required this.merchID, required this.orderID}) : super(key: key);
  final String merchID;
  final String orderID;
  @override
  _transactionStatusURLState createState() => _transactionStatusURLState();
}

class _transactionStatusURLState extends State<transactionStatusURL> {

  var strTrans;
  bool isLoading=true;



  Digest hMAC256 (){
    String base64Key = '0678056d96914a8583fb518caf42828a';
    String message = '{"merchantIdentifier":"${widget.merchID}","mode":"0","orderDetail":{"orderId":"${widget.orderID}"}}';

    var messageBytes = utf8.encode(message);
    var key = utf8.encode(base64Key);
    var hmac = new Hmac(sha256, key);
    var base64Mac=hmac.convert(messageBytes);
    log(message);
    log(base64Mac.toString());
    return base64Mac;

  }

  jsonResponsetrans() async {
    var request = http.Request('POST', Uri.parse('https://zaakstaging.zaakpay.com/checkTxn?v=5'));
    request.bodyFields = {'data': '{"merchantIdentifier":"${widget.merchID}","mode":"0","orderDetail":{"orderId":"${widget.orderID}"}}',
      'checksum': '${hMAC256()}'};
    http.StreamedResponse response = await request.send();

    if (response.statusCode == 200) {

      var responses= await response.stream.bytesToString();

      var finalResponse=json.decode(responses);
      setState(() {
        strTrans=finalResponse;
        isLoading=false;
      });
      return finalResponse;
    }
    else {
      print(response.reasonPhrase);
    }
  }


  @override

  void initState(){

    super.initState();
    jsonResponsetrans();
    log(strTrans.toString());
  }


  @override
  Widget build(BuildContext context) {
    log(strTrans.toString());
    return Scaffold(
      appBar: AppBar(
        centerTitle: true,
        title: Text('Check Transaction portal'),
      ),
      body: Center(

        child: isLoading ? CircularProgressIndicator() : Center(
          child: Container(
              child:Center(
                child: Column(
                  children: [
                    Center(
                      child: Container(

                        child:Column(
                          children: [
                            Text("Success code: ${strTrans["success"]}" ,
                                textAlign: TextAlign.center),

                            Text("Merchant Identifier : ${strTrans["merchantIdentifier"]}",
                                textAlign: TextAlign.center),

                            Text("Order ID : ${strTrans["orders"][0]["orderDetail"]["orderId"]}",
                                textAlign: TextAlign.center),

                            Text("Reponse Code : ${strTrans["orders"][0]["responseCode"]}",
                                textAlign: TextAlign.center),

                            Text("Response Description : ${strTrans["orders"][0]["responseDescription"]}",
                                textAlign: TextAlign.center)
                          ],
                        ),
                      ),
                    ),




                  ],
                ),
              )
          ),
        ),
      ),
    );
  }
}


//ZP202202151706deep